# File-related utilities for gracedb-client.
# I was having trouble with sending form-encoded (lists) as part of
# MultipartEncoded streams. For example.

# from requests_toolbelt import MultipartEncoder

# body = {'comment': 'yay',
#  'tagname': ['tagtest1', 'tagtest2'],
#  'upload': ('test_file_upload',
#   <_io.BufferedReader name='./ligo-gracedb.spec'>,
#   'text/plain')}

# m = MultipartEncoder(body)

# m.to_string()
# b'--aa9670d191ae4a38894ac8334bcc8895\r\nContent-Disposition: form-data;
# name="comment"\r\n\r\nyay\r\n--aa9670d191ae4a38894ac8334bcc8895\r\nContent-Disposition:
# form-data; name="tagname";
# filename="tagtest1"\r\n\r\ntagtest2\r\n--aa9670d191ae4a38894ac8334bcc8895\r\nContent-Disposition:
# form-data; name="upload"; filename="test_file_upload"\r\nContent-Type:
# text/plain\r\n\r\n\r\n--aa9670d191ae4a38894ac8334bcc8895--\r\n'

# Then everything uploads (post(uri, data=m, headers={'Content-Type':
# m.content_type})) Except it only takes the first entry in the list.
# Experiment more with this later.

import mimetypes
import six


# ----------------------------------------------------------------
# HTTP upload encoding
# Taken from http://code.activestate.com/recipes/146306/
def encode_multipart_formdata(fields, files):
    """
    fields is a sequence of (name, value) elements for regular form fields.
    files is a sequence of (name, filename, value) elements for data to be
        uploaded as files.
    Returns (content_type, body) ready for httplib.HTTP instance
    """
    BOUNDARY = '----------ThIs_Is_tHe_bouNdaRY_$'
    CRLF = b'\r\n'
    L = []
    for (key, value) in fields:
        if value is None:
            continue
        L.append(('--' + BOUNDARY).encode())
        L.append('Content-Disposition: form-data; name="{0}"'.format(
            key).encode())
        L.append(''.encode())
        # encode in case it is unicode
        if isinstance(value, six.binary_type):
            L.append(value)
        elif isinstance(value, six.text_type):
            L.append(value.encode())
        else:
            L.append(str(value).encode())
    for (key, filename, value) in files:
        if value is None:
            continue
        L.append(('--' + BOUNDARY).encode())
        # str(filename) in case it is unicode
        L.append(('Content-Disposition: form-data; name="{0}"; '
                 'filename="{1}"').format(key, filename).encode())
        L.append('Content-Type: {0}'.format(get_content_type(filename))
                 .encode())
        L.append(''.encode())
        if isinstance(value, six.text_type):
            L.append(value.encode())
        else:
            L.append(value)
    L.append(('--' + BOUNDARY + '--').encode())
    L.append(''.encode())
    body = CRLF.join(L)
    content_type = 'multipart/form-data; boundary={0}'.format(BOUNDARY) \
        .encode()
    return content_type, body


def get_content_type(filename):
    return mimetypes.guess_type(filename)[0] or 'application/octet-stream'
